unit tools;      { a collection of non-screen orientated procs and funcs }
{ Written by Hunter Beanland - www.geocities.com/hbeanland }
{$I-}
interface

uses dos,crt,sysextrn;
{type  str130=string[130];}
var reg:registers;
    filein,fileout,line:string;
    cpu,q,ii,err:integer;
    ch:char;

procedure cuon;
procedure cuoff;
procedure tab(n:integer);
function  centre(lin:string):string;
function  comma(num:longint):string;
procedure kbdflush;
procedure kbdstat(num:integer);
procedure kbdrate(dd,rr:integer);                     { 0..3, 0..30 }
procedure getnum(le,min,max,def:integer; var res:integer);
procedure getstr(le:integer; def:string; var res:string);
procedure pause;
procedure upstr(var line:string);
procedure trim(var line:string);
function left(var line:string; ind:integer):string;
function right(var line:string; ind:integer):string;
procedure cpuinfo(var cpu:integer; var fpu:boolean);  { 1=? 0=xt 2=286.. }
procedure wait(wai:longint);
procedure beep;
function  date:string;                                { dd-mm-yy (day) }
function  time:string;                                { hh:mm:ss Xm }
function  ldate:string;                               { day, dd month yyyy }
function  ltime:string;                               { hh:mm:ss }{(24hr)}
procedure fcopy(fin,fout:string);
procedure fdel(filen:string);
procedure fren(oldn,newn:string);
function  getdrv:integer;                             { 0=a }
procedure setdrv(drv:integer);                        { 0=a, 1=b.. }
function  hex(a:word; b:byte):string;                 { #=a, len=b }
function  bb2w(a,b:byte):word;                        { hi=b, lo=a }
function  Dec2Hex(d:LONGINT; width:BYTE):STRING;
function  hex2dec(hex:string):integer;              {input 2 dig hex number}
function  num2str(num:longint):string;

implementation

procedure cuon;
begin asm
 mov ah,$01
 mov ch,11
 mov cl,13
 int $10
end; end;

procedure cuoff;
begin asm
 mov ah,$01
 mov ch,$20
 int $10
end; end;

procedure tab;
begin
 gotoxy(n,wherey);
end;

function centre;
begin
 ii:=(lo(windmax)+1)-(lo(windmin)+1);
 gotoxy((ii div 2)-(length(lin) div 2),wherey);
 centre:=lin;
end;

function comma;
begin
 str(num,line);
 ii:=length(line);
 while ii>3 do
 begin
  insert(',',line,ii-2);
  ii:=ii-3;
 end;
 comma:=line;
end;

procedure kbdflush;
begin
 while keypressed do ch:=readkey;
end;

procedure kbdstat;
begin
 mem[0:1047]:=num;
end;

procedure kbdrate;
begin
 reg.ah:=$03;
 reg.al:=$05;
 reg.ax:=$0305;
 reg.bl:=rr;
 reg.bh:=dd;
 intr($16,reg);
end;

procedure edline(le:integer);
var stx:integer;
 past:boolean;
begin
 stx:=wherex;
 line:='';
 for q:=1 to le do line:=line+' ';
 q:=1;
 repeat
  ch:=readkey;
  if ch >#31 then begin
   line[q]:=ch;
   write(ch);
   inc(q);
   if q-1=le then begin past:=true; dec(q); gotoxy(wherex-1,wherey); end
   else past:=false;
  end
  else begin
   if ch=#00 then ch:=readkey;
   case ch of
    #8:  begin
          if (q=le) and past then write('_'#8)
          else begin
           dec(q);
           if q=0 then q:=1
           else write(#8'_'#8);
          end;
          line[q]:=' ';
          past:=false;
         end;
    #13: q:=0;
    #27: begin line:=''; q:=0; end;
    #75: begin
          dec(q);
          if q=0 then q:=1
          else write(#8);
          past:=false;
         end;
    #77: begin
          inc(q);
          if q-1=le then begin dec(q); past:=true; end
          else gotoxy(wherex+1,wherey);
         end;
   end;
  end;
 until q=0;
 gotoxy(stx,wherey);
 write(line);
 gotoxy(stx,wherey);
 while copy(line,length(line),1)=' ' do delete(line,length(line),1);
end;

procedure getnum;
var oldx:integer;
begin
 oldx:=wherex;
 repeat
  for ii:=1 to le do write('_');
  gotoxy(oldx,wherey);
  edline(le);
  if line='' then begin
   str(def,line);
   write(line);
  end;
  val(line,res,err);
  if res<min then err:=1;
  if res>max then err:=1;
  gotoxy(oldx,wherey);
 until err=0;
end;

procedure getstr;
begin
 q:=wherex;
 for ii:=1 to le do write('_');
 gotoxy(q,wherey);
 edline(le);
 if line='' then begin
  res:=def;
  write(res);
 end
 else res:=line;
end;

procedure pause;
begin
 kbdflush;
 ch:=readkey;
end;

procedure upstr;
begin
 for ii:=1 to length(line) do
  line[ii]:=upcase(line[ii]);
end;

procedure trim;
begin
  while (length(line)>0) and (line[1]=' ') do
    delete(line,1,1);
  while (length(line)>0) and (line[length(line)]=' ') do
    delete(line,length(line),1);
end;

function left;
begin
  left:=copy(line,1,ind);
end;

function right;
begin
  right:=copy(line,length(line)+1-ind,ind);
end;

procedure cpuinfo;
var cpuinform:cpu_info_t;
begin
 fpu:=false;
 cpu:=1;
 with cpuinform do
 begin
  test_type:='C';
  cpuid(cpuinform);
  case cpu_type of
  0..$05: cpu:=0;
     $06: cpu:=2;
     $07: cpu:=3;
     $08: cpu:=4;
  end;
  test_type:='N';
  cpuid(cpuinform);
  if ndp_type=$00 then fpu:=false
  else fpu:=true;
 end;
end;

procedure wait;
var temp:longint;
begin
if cpu=0 then delay(wai)
else begin
 reg.ah:=$86;
 temp:=wai*1000;
 reg.cx:=temp div 65535;
 reg.dx:=word(temp-longint(reg.cx*65535));
 intr($15,reg);
end;
end;

procedure beep;
begin
 sound(2000);
 wait(200);
 nosound;
end;

function date;
  var ye,mn,yy,d:word;
  mi:string[4];
  tm,dn:string[10];
 begin
   getdate(ye,mn,d,yy);
   case yy of
    0: dn:='SUN';
    1: dn:='MON';
    2: dn:='TUE';
    3: dn:='WED';
    4: dn:='THU';
    5: dn:='FRI';
    6: dn:='SAT';
   end;
   mi:='';
{   reg.ah:=$38;
   reg.dx:=0;
   reg.al:=0;
   reg.ds:=seg(line);
   reg.dx:=ofs(line);
   msdos(reg);
   ii:=lo(reg.bx);}
   line:='';
{   if ii=1 then begin     {USA}
{    if d<10 then mi:='0';
    str(mn:2,tm);
    tm:=tm+'-'+mi;   {mm-0}
 {   str(d,mi);
    tm:=tm+mi;       {mm-dd}
{   end
   else begin            {Int'l Eng}
    if mn<10 then mi:='0';
    str(d:2,tm);
    tm:=tm+'-'+mi;   {dd-0}
    str(mn,mi);
    tm:=tm+mi;       {dd-mm}
 {  end;}
   str(ye,mi);
   mi:=copy(mi,3,2);
   date:=tm+'-'+mi+' ('+dn+')';
 end;

function time;
var h,m,s,a:word;
    mi,dn,sc:string[2];
    tm:string[10];
begin
   gettime(h,m,s,a);
   mi:='';
   if m<10 then
    mi:='0';
   dn:=' a';
   if h>11 then
   begin
    h:=h-12;
    dn:=' p';
    if h=0 then h:=12;
   end;
   str(h:2,tm);
   str(m,sc);
   tm:=tm+':'+mi+sc+':';  { hh:0m: }
   if s<10 then sc:='0'
   else sc:='';
   str(s,mi);
   time:=tm+sc+mi+dn+'m';
end;

function ldate;
  var ye,mn,yy,d:word;
  mi:string[4];
  tm,mo,da:string[10];
const
  mon:array[1..12] of string[9]=('January','February','March','April','May',
        'June','July','August','September','October','November','December');
  day:array[0..6] of string[9]=('Sunday','Monday','Tuesday','Wednesday',
                  'Thursday','Friday','Saturday');
 begin
   getdate(ye,mn,d,yy);
   mo:=mon[mn];
   da:=day[yy];
   str(d,tm);
   str(ye,mi);
   ldate:=da+', '+tm+' '+mo+' '+mi;
 end;

function ltime;
var h,m,s,a:word;
    mi,sc:string[2];
    tm:string[10];
begin
   gettime(h,m,s,a);
   mi:='';
   if m<10 then
    mi:='0';
   str(h:2,tm);
   str(m,sc);
   tm:=tm+':'+mi+sc+':';  { hh:0m: }
   if s<10 then sc:='0'
   else sc:='';
   str(s,mi);
   ltime:=tm+sc+mi;
end;

procedure fcopy;
{var fsp:searchrec;
qw:longint;}
var
  NumRead, NumWritten: Word;
  Buf: array[1..2048] of Char;
  infile,outfile:file;
  attr:word;
begin
   filein:=fin;
   fileout:=fout;
   assign(infile,filein);
   getfattr(infile,attr);
   setfattr(infile,0);
   doserror:=0;
   err:=ioresult; {clear reg}
   reset(infile,1);
   if ioresult<>0 then begin err:=1; exit; end;
   assign(outfile,fileout);
   setfattr(outfile,0);
   rewrite(outfile,1);
   if ioresult<>0 then begin err:=2; exit; end;
  repeat
    BlockRead(infile, Buf, SizeOf(Buf), NumRead);
    if ioresult<>0 then begin err:=1; exit; end;
    BlockWrite(outfile, Buf, NumRead, NumWritten);
    if ioresult<>0 then begin err:=2; exit; end;
  until (NumRead = 0) or (NumWritten <> NumRead);
{   findfirst(inf,anyfile,fsp);
    for qw:=1 to fsp.size do begin blockread
    read(infile,ch);
    write(outfile,ch);
  end;}
   setfattr(infile,attr);
   close(infile);
   close(outfile);
   err:=0;
end;

procedure fdel;
begin
 filen:=filen+#0;
 reg.ah:=$41;
 reg.ds:=seg(filen[1]);
 reg.dx:=ofs(filen[1]);
 msdos(reg);
 err:=reg.flags;
end;

procedure fren;
begin
 reg.ax:=$5600;
 reg.ds:=seg(oldn[1]);
 reg.dx:=ofs(oldn[1]);
 reg.es:=seg(newn[1]);
 reg.di:=ofs(newn[1]);
 msdos(reg);
 err:=reg.flags;
end;

function getdrv;
begin
 reg.ax:=$1900;
 msdos(reg);
 err:=reg.flags;
 getdrv:=lo(reg.ax);
end;

procedure setdrv;
begin
 reg.ax:=$0e00;
 reg.dx:=drv;
 msdos(reg);
 err:=reg.flags;
end;

function hex;
 const digit : array[$0..$F] of char = '0123456789ABCDEF';
 var i : byte;
 begin
  line:='';
  for i:=1 to b do begin
   insert(digit[a and $000F],line,1);
   a:=a shr 4
  end;
  hex:=line
 end;

function bb2w;
 begin
  bb2w:=word(b) shl 8 + a
 end;

FUNCTION Dec2Hex;
{
  Converts a decimal based number to a hexadecimal based number with
  width 'width', the number being defined by 'd'.
}
const hexdigits:STRING='0123456789ABCDEF';
VAR result:STRING;
    i,j:BYTE;
BEGIN
  result:='00000000';
  j:=8;
  WHILE (d<>0) DO
  BEGIN
    i:=(d AND $0000000F);
    d:=d SHR 4;
    result[j]:=HexDigits[i+1];
    Dec(j);
  END;
  result:=Copy(result,8-width+1,width);
  Dec2Hex:=result;
END;

function hex2dec;  {input 2 dig hex number}
const hexdigits:STRING='0123456789ABCDEF';
var e,result,result2:integer;
begin
  for e:=1 to 16 do
    if hexdigits[e]=hex[1] then result:=e-1;
  for e:=1 to 16 do
    if hexdigits[e]=hex[2] then result2:=e-1;
  hex2dec:=result*16+result2;
end;

function num2str;
var newstr:string;
begin
  str(num,newstr);
  num2str:=newstr;
end;


end.